from .util import *
from pytz import timezone

min_date, max_date = 19900000, 20300000
def All2Dt(date = dt.datetime.today()):
  if isinstance(date, int):
    if date > max_date or date < min_date:
      p('invalid date num', date, 'should in (%d, %d)'%(min_date, max_date), color='red')
      return ''
    date = dt.datetime.strptime(str(date), '%Y%m%d')
  elif isinstance(date, str):
    if date == '':
      date = dt.datetime.today()
    elif (len(date) == 8 and date.isdigit() == True) or (len(date) == 10 and date.replace('-', '').isdigit() == True):
      date = dt.datetime.strptime(date.replace('-', ''), '%Y%m%d')
    else:
      p('invalid date str', date, 'length should be 8 or 10(with -)', color='red')
      return ''
  elif isinstance(date, dt.datetime):
    #date.replace(tzinfo=timezone('UTC')).astimezone(tz=timezone('Asia/Shanghai'))
    pass
  elif isinstance(date, dt.date):
    date = dt.datetime.strptime(date.isoformat(), '%Y-%m-%d').astimezone(tz=timezone('Asia/Shanghai'))
  else:
    p('invalid inputtype', date, type(date))
    return ''
  return date.astimezone(tz=timezone('Asia/Shanghai'))

def QDate(date=dt.datetime.today().date(), diff=0, split_c='-', ignore_weekend=False):
  date = All2Dt(date)
  if date == '':
    p('QueryDate failed', color='red')
    return ''
  format_str = '%Y' + split_c + '%m' + split_c + '%d'
  if ignore_weekend:
    oneday, oneweek = dt.timedelta(1), dt.timedelta(7)
    num_week = int(abs(diff) / 5) * np.sign(diff)
    num_day = int(abs(diff) % 5) * np.sign(diff)
    date += oneweek * num_week
    date += oneday * num_day
  else:
    date += dt.timedelta(diff)
  return date.strftime(format_str)

def Translate(date, topic='tm', weekday=5, weekno=3, split_c='-'):
  date = All2Dt(date)
  if date == '':
    p('QueryDate failed', color='red')
    return ''
  oneday, oneweek = dt.timedelta(1), dt.timedelta(7)
  weekday_num = (weekday + 6) % 7
  format_str = '%Y' + split_c + '%m' + split_c + '%d'
  if topic == 'next':
    diff = (weekday_num - date.weekday()) % 7
    return date + diff * oneday
  elif topic == 'tw':  # tw may be same with w if the date not cross the 3rd friday, tw must be this week, the output date may be earlier than input
    diff = (weekday_num - date.weekday())# % 7
    return date + diff * oneday
  elif topic == 'tm':
    first_date = dt.datetime(date.year, date.month, 1).astimezone(tz=timezone('Asia/Shanghai'))
    return Translate(first_date, topic='w', weekday=weekday, split_c = split_c) + (weekno - 1) * oneweek
  elif topic == 'w':
    diff = (weekday_num - date.weekday()) % 7
    return date + diff * oneday
  elif topic == 'm': # next month expire date
    first_date = Translate(date, topic='tm', weekday = weekday, weekno=weekno, split_c=split_c)
    #print('firstdate', first_date, date)
    return first_date if date <= first_date else Translate(date, topic='nm', weekday = weekday, weekno=weekno, split_c=split_c)
  elif topic == 'q':
    month = date.month
    while month % 3 != 0:
      month += 1
    first_date = dt.datetime(year=date.year, month=month, day=1).astimezone(tz=timezone('Asia/Shanghai'))
    this_qdate = Translate(first_date, topic = 'tm', weekday = weekday, weekno=weekno, split_c=split_c)
    if this_qdate >= date:
      return this_qdate
    else:
      next_date = Translate(this_qdate, topic = 'nm', weekday = weekday, weekno=weekno, split_c=split_c)
      return Translate(next_date, topic = 'q', weekday = weekday, weekno=weekno, split_c=split_c)
  elif topic == 'qq':
    tmd = Translate(date, topic = 'm', weekday = weekday, weekno=weekno, split_c=split_c)
    tqd = Translate(date, topic = 'q', weekday = weekday, weekno=weekno, split_c=split_c)
    return tqd if tqd > tmd else Translate(tqd+oneday, topic = 'q', weekday = weekday, weekno=weekno, split_c=split_c)
  elif topic == 'nw':
    date += oneday*7
    return Translate(date, topic = 'tw', weekday = weekday, split_c=split_c)
  elif topic == 'nm':
    if date.month == 12:
      first_date = dt.datetime(date.year+1, 1, date.day).astimezone(tz=timezone('Asia/Shanghai'))
    else:
      first_date = dt.datetime(date.year, date.month+1, 1).astimezone(tz=timezone('Asia/Shanghai'))
    return Translate(first_date, topic = 'tm', weekday = weekday, weekno=weekno, split_c=split_c)
  #elif topic == 'lw':
  #elif topic == 'lm':
  #elif topic == 'lq':
  else:
    p('topic invalid', topic, color='red')
    return ''
  return ''

'''
  elif topic == 'ww':
    twd = Translate(date, topic = 'w', weekday = weekday, weekno=weekno, split_c=split_c)
    wwd = Translate(date, topic = 'nw', weekday = weekday, weekno=weekno, split_c=split_c)
    return wwd if wwd > twd else Translate(wwd, topic = 'w', weekday = weekday, weekno=weekno, split_c=split_c)
  elif topic == 'mm':
    tmd = Translate(date, topic = 'm', weekday = weekday, weekno=weekno, split_c=split_c)
    mmd = Translate(date, topic = 'nm', weekday = weekday, weekno=weekno, split_c=split_c)
    return mmd if mmd > tmd else Translate(mmd, topic = 'q', weekday = weekday, weekno=weekno, split_c=split_c)
'''
def QTicker(con, date='', topic='m', mode = 'cffex'):
  con = GetCon(con)
  rm = 2 if mode in ['cffex', 'shfe'] else 3 if mode in ['dce', 'zce'] else 2
  weekday = 5
  weekno = 3  # TODO: weekday and weekno need to define by exchange rule
  d = Translate(date, topic = topic, weekday = weekday, weekno=weekno)
  return con + d.strftime('%Y%m')[rm:]

def SQTicker(ticker, date='', smart_c = '+', mode = 'cffex'):
  s = ticker.split(smart_c)
  con = s[0]
  topic = s[1].lower()
  return QTicker(con, date, topic, mode)

def TransInt2Int(a):
  s = str(a)
  if len(s) > 6: s = s[:-3]
  sec = int(s[-2:])
  min = int(s[-4:-2])
  hour = int(s[:-4])
  return hour*3600 + min * 60 + sec

if __name__ == '__main__':
  #p(QDate('20190101', -21, ignore_weekend=True))
  #p(Translate('2020-11-22', topic='q', weekday=5, weekno=3))
  #p(Translate('2020-12-18', topic='qq', weekday=5, weekno=3))
  #p(QTicker('IC', date='2020-11-22', topic='qq', mode='cffex'))
  #p(QTicker('IC', date='2020-11-22', topic='m', mode='cffex'))
  p(SQTicker('IC+qq', '2020-01-30'))
  p(TransInt2Int(91010000))
